
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Return_itemsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const return_items = await db.return_items.create(
            {
                id: data.id || undefined,
        
        quantity: data.quantity
        ||
        null
            ,
            
        unit_price: data.unit_price
        ||
        null
            ,
            
        vat_rate: data.vat_rate
        ||
        null
            ,
            
        vat_amount: data.vat_amount
        ||
        null
            ,
            
        refund_amount: data.refund_amount
        ||
        null
            ,
            
        condition_notes: data.condition_notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await return_items.setReturn( data.return || null, {
            transaction,
        });
        
        await return_items.setSale_item( data.sale_item || null, {
            transaction,
        });
        
        await return_items.setProduct( data.product || null, {
            transaction,
        });
        
        await return_items.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return return_items;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const return_itemsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                quantity: item.quantity
            ||
            null
            ,
            
                unit_price: item.unit_price
            ||
            null
            ,
            
                vat_rate: item.vat_rate
            ||
            null
            ,
            
                vat_amount: item.vat_amount
            ||
            null
            ,
            
                refund_amount: item.refund_amount
            ||
            null
            ,
            
                condition_notes: item.condition_notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const return_items = await db.return_items.bulkCreate(return_itemsData, { transaction });

        // For each item created, replace relation files
        

        return return_items;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const return_items = await db.return_items.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.quantity !== undefined) updatePayload.quantity = data.quantity;
        
        
        if (data.unit_price !== undefined) updatePayload.unit_price = data.unit_price;
        
        
        if (data.vat_rate !== undefined) updatePayload.vat_rate = data.vat_rate;
        
        
        if (data.vat_amount !== undefined) updatePayload.vat_amount = data.vat_amount;
        
        
        if (data.refund_amount !== undefined) updatePayload.refund_amount = data.refund_amount;
        
        
        if (data.condition_notes !== undefined) updatePayload.condition_notes = data.condition_notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await return_items.update(updatePayload, {transaction});

        
        
        if (data.return !== undefined) {
            await return_items.setReturn(
              
              data.return,
              
              { transaction }
            );
        }
        
        if (data.sale_item !== undefined) {
            await return_items.setSale_item(
              
              data.sale_item,
              
              { transaction }
            );
        }
        
        if (data.product !== undefined) {
            await return_items.setProduct(
              
              data.product,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await return_items.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return return_items;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const return_items = await db.return_items.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of return_items) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of return_items) {
                await record.destroy({transaction});
            }
        });


        return return_items;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const return_items = await db.return_items.findByPk(id, options);

        await return_items.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await return_items.destroy({
            transaction
        });

        return return_items;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const return_items = await db.return_items.findOne(
            { where },
            { transaction },
        );

        if (!return_items) {
            return return_items;
        }

        const output = return_items.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.return = await return_items.getReturn({
            transaction
        });
        
        
        output.sale_item = await return_items.getSale_item({
            transaction
        });
        
        
        output.product = await return_items.getProduct({
            transaction
        });
        
        
        output.organizations = await return_items.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.returns,
        as: 'return',
        
        where: filter.return ? {
          [Op.or]: [
            { id: { [Op.in]: filter.return.split('|').map(term => Utils.uuid(term)) } },
            {
              return_number: {
                [Op.or]: filter.return.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.sale_items,
        as: 'sale_item',
        
        where: filter.sale_item ? {
          [Op.or]: [
            { id: { [Op.in]: filter.sale_item.split('|').map(term => Utils.uuid(term)) } },
            {
              product_name_snapshot: {
                [Op.or]: filter.sale_item.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.products,
        as: 'product',
        
        where: filter.product ? {
          [Op.or]: [
            { id: { [Op.in]: filter.product.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.product.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.condition_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'return_items',
                        'condition_notes',
                        filter.condition_notes,
                    ),
                };
            }
            

            
            

            
            if (filter.quantityRange) {
                const [start, end] = filter.quantityRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    quantity: {
                    ...where.quantity,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.unit_priceRange) {
                const [start, end] = filter.unit_priceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    unit_price: {
                    ...where.unit_price,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.vat_rateRange) {
                const [start, end] = filter.vat_rateRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    vat_rate: {
                    ...where.vat_rate,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.vat_amountRange) {
                const [start, end] = filter.vat_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    vat_amount: {
                    ...where.vat_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    vat_amount: {
                    ...where.vat_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.refund_amountRange) {
                const [start, end] = filter.refund_amountRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    refund_amount: {
                    ...where.refund_amount,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    refund_amount: {
                    ...where.refund_amount,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            


      

      

      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.return_items.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'return_items',
                        'refund_amount',
                        query,
                    ),
                ],
            };
        }

        const records = await db.return_items.findAll({
            attributes: [ 'id', 'refund_amount' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['refund_amount', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.refund_amount,
        }));
    }

    
};

